<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>tools/sequences.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tools/sequences.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2004-2006 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_SEQUENCES__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_SEQUENCES__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;behaviourlayer/behave.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;tools/parameters.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">// Sequence operations</span>
<a name="l00029"></a>00029 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00030"></a>00030 
<a name="l00037"></a><a class="code" href="structiSeqOp.html">00037</a> <span class="keyword">struct </span><a class="code" href="structiSeqOp.html" title="This is a sequence operation.">iSeqOp</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   SCF_INTERFACE (<a class="code" href="structiSeqOp.html" title="This is a sequence operation.">iSeqOp</a>, 0, 0, 1);
<a name="l00040"></a>00040   
<a name="l00047"></a>00047   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiSeqOp.html#acece088c32e0ad0ebc4db45bb6600067" title="Init the operation.">Init</a> (<a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params) = 0;
<a name="l00048"></a>00048 
<a name="l00052"></a>00052   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiSeqOp.html#a87f951f9e51993b3ee4d60a6f48556e2" title="Load the sequence operation from persisted data.">Load</a> (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf) = 0;
<a name="l00053"></a>00053 
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiSeqOp.html#a7219a7ea7697ea5f4b132b9e0c166445" title="Save the sequence operation to persisted data.">Save</a> (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf) = 0;
<a name="l00058"></a>00058 
<a name="l00064"></a>00064   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiSeqOp.html#a4440ac766e77dda9f1985f6cff25dced" title="Do the operation.">Do</a> (<span class="keywordtype">float</span> time, <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params) = 0;
<a name="l00065"></a>00065 };
<a name="l00066"></a>00066 
<a name="l00071"></a><a class="code" href="structiSeqOpFactory.html">00071</a> <span class="keyword">struct </span><a class="code" href="structiSeqOpFactory.html" title="A factory to create sequence operators.">iSeqOpFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073   SCF_INTERFACE (<a class="code" href="structiSeqOpFactory.html" title="A factory to create sequence operators.">iSeqOpFactory</a>, 0, 0, 1);
<a name="l00074"></a>00074 
<a name="l00080"></a>00080   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iSeqOp&gt;</a> <a class="code" href="structiSeqOpFactory.html#a1f9a9bb0b69288ee13573c3891952a63" title="Create a sequence operation.">CreateSeqOp</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a>&amp; params) = 0;
<a name="l00081"></a>00081 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiSeqOpFactory.html#a09c59f7870941dd33f41e999c8f6cc42" title="Load this factory from a document node.">Load</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiDocumentNode.html">iDocumentNode</a>* node) = 0;
<a name="l00088"></a>00088 };
<a name="l00089"></a>00089 
<a name="l00095"></a><a class="code" href="structiSeqOpType.html">00095</a> <span class="keyword">struct </span><a class="code" href="structiSeqOpType.html" title="The seqop type is responsible for the creation of seqop factories.">iSeqOpType</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097   SCF_INTERFACE (<a class="code" href="structiSeqOpType.html" title="The seqop type is responsible for the creation of seqop factories.">iSeqOpType</a>, 0, 0, 1);
<a name="l00098"></a>00098 
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiSeqOpType.html#ac4a73a9264c794ccdd7880e636f7ca30" title="Return the name for this sequence operation type.">GetName</a> () <span class="keyword">const</span> = 0;
<a name="l00103"></a>00103   
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iSeqOpFactory&gt;</a> <a class="code" href="structiSeqOpType.html#a36ec4e7f100e567a857e80dd84f45139" title="Create a sequence operation factory.">CreateSeqOpFactory</a> () = 0;
<a name="l00108"></a>00108 };
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="keyword">struct </span><a class="code" href="structiCelSequence.html" title="A sequence.">iCelSequence</a>;
<a name="l00111"></a>00111 
<a name="l00116"></a><a class="code" href="structiCelSequenceCallback.html">00116</a> <span class="keyword">struct </span><a class="code" href="structiCelSequenceCallback.html" title="This callback is fired when the sequences finished running properly.">iCelSequenceCallback</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118   SCF_INTERFACE (<a class="code" href="structiCelSequenceCallback.html" title="This callback is fired when the sequences finished running properly.">iCelSequenceCallback</a>, 0, 0, 1);
<a name="l00119"></a>00119 
<a name="l00121"></a>00121   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelSequenceCallback.html#a0ee28cd13e2b2a5082bc8178c164d8d1" title="Sequence finishes.">SequenceFinished</a> (<a class="code" href="structiCelSequence.html" title="A sequence.">iCelSequence</a>* sequence) = 0;
<a name="l00122"></a>00122 };
<a name="l00123"></a>00123 
<a name="l00127"></a><a class="code" href="structiCelSequence.html">00127</a> <span class="keyword">struct </span><a class="code" href="structiCelSequence.html" title="A sequence.">iCelSequence</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129   SCF_INTERFACE (<a class="code" href="structiCelSequence.html" title="A sequence.">iCelSequence</a>, 0, 0, 1);
<a name="l00130"></a>00130 
<a name="l00134"></a>00134   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelSequence.html#a78578ae6f3caa49334367abb941149ba" title="Get the name of this sequence.">GetName</a> () <span class="keyword">const</span> = 0;
<a name="l00135"></a>00135 
<a name="l00139"></a>00139   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelSequence.html#adf58ed7f2cba1ab81542e5c367ea9a09" title="Save state of this sequence.">SaveState</a> (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf) = 0;
<a name="l00143"></a>00143   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelSequence.html#a1c4ab112920cd2084de30cb9ddbcfdb5" title="Load state of this sequence.">LoadState</a> (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf) = 0;
<a name="l00144"></a>00144 
<a name="l00150"></a>00150   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelSequence.html#a6460a1fbb2ecf61be75f22ecc7a7fc48" title="Fire this sequence.">Start</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> delay, <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params) = 0;
<a name="l00151"></a>00151 
<a name="l00158"></a>00158   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelSequence.html#a63c5257715c993078d072df59c8dc533" title="Finish this sequence.">Finish</a> () = 0;
<a name="l00159"></a>00159 
<a name="l00165"></a>00165   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelSequence.html#aa7f15bc87d87f2c2b3bb1549c9a5c3ef" title="Abort this sequence.">Abort</a> () = 0;
<a name="l00166"></a>00166 
<a name="l00170"></a>00170   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelSequence.html#ade682270a70e9a3376bb02b7927cfae1" title="Return true if this sequence is currently running.">IsRunning</a> () = 0;
<a name="l00171"></a>00171 
<a name="l00175"></a>00175   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelSequence.html#a13d345168cc0ba16b74237d474c7639a" title="Register a callback that is fired when this sequence finishes.">AddSequenceCallback</a> (<a class="code" href="structiCelSequenceCallback.html" title="This callback is fired when the sequences finished running properly.">iCelSequenceCallback</a>* cb) = 0;
<a name="l00179"></a>00179   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelSequence.html#af73a002a200c8d4c755b73ea09af21f2" title="Remove a callback.">RemoveSequenceCallback</a> (<a class="code" href="structiCelSequenceCallback.html" title="This callback is fired when the sequences finished running properly.">iCelSequenceCallback</a>* cb) = 0;
<a name="l00180"></a>00180 };
<a name="l00181"></a>00181 
<a name="l00186"></a><a class="code" href="structiCelSequenceFactory.html">00186</a> <span class="keyword">struct </span><a class="code" href="structiCelSequenceFactory.html" title="A representation of a sequence factory.">iCelSequenceFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00187"></a>00187 {
<a name="l00188"></a>00188   SCF_INTERFACE (<a class="code" href="structiCelSequenceFactory.html" title="A representation of a sequence factory.">iCelSequenceFactory</a>, 0, 0, 1);
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelSequence&gt;</a> CreateSequence (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a>&amp; params) = 0;
<a name="l00191"></a>00191 
<a name="l00195"></a>00195   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelSequenceFactory.html#ac60f4e6ea04d9437b9d6355dec8b18e2" title="Get the name of this factory.">GetName</a> () <span class="keyword">const</span> = 0;
<a name="l00196"></a>00196   
<a name="l00200"></a>00200   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelSequenceFactory.html#aaf72d2d6bfd407f9fa2a962e0091d77a" title="Set the name of this factory.">SetName</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* name) = 0;
<a name="l00201"></a>00201 
<a name="l00209"></a>00209   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelSequenceFactory.html#a9b17ec042d9af2d93ffb0a6d21581cf8" title="Add a new operation factory at the specified time.">AddSeqOpFactory</a> (<a class="code" href="structiSeqOpFactory.html" title="A factory to create sequence operators.">iSeqOpFactory</a>* seqopfact,
<a name="l00210"></a>00210         <span class="keyword">const</span> <span class="keywordtype">char</span>* duration) = 0;
<a name="l00211"></a>00211 
<a name="l00216"></a>00216   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelSequenceFactory.html#a075514025ef791959ae9864d847fd186" title="Add a delay.">AddDelay</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* delay) = 0;
<a name="l00217"></a>00217 };
<a name="l00218"></a>00218 
<a name="l00222"></a><a class="code" href="structiCelSequenceFactoryGenerator.html">00222</a> <span class="keyword">struct </span><a class="code" href="structiCelSequenceFactoryGenerator.html" title="This is the actual plugin which can generate sequence factories.">iCelSequenceFactoryGenerator</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00223"></a>00223 {
<a name="l00224"></a>00224   SCF_INTERFACE (<a class="code" href="structiCelSequenceFactoryGenerator.html" title="This is the actual plugin which can generate sequence factories.">iCelSequenceFactoryGenerator</a>, 0, 0, 1);
<a name="l00225"></a>00225 
<a name="l00226"></a>00226   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelSequenceFactory&gt;</a> CreateSequenceFactory () = 0;
<a name="l00227"></a>00227 };
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00230"></a>00230 <span class="comment">// Specific sequence operation implementations.</span>
<a name="l00231"></a>00231 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00232"></a>00232 
<a name="l00245"></a><a class="code" href="structiDebugPrintSeqOpFactory.html">00245</a> <span class="keyword">struct </span><a class="code" href="structiDebugPrintSeqOpFactory.html" title="This interface is implemented by the seqop that prints debug messages on standard output...">iDebugPrintSeqOpFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00246"></a>00246 {
<a name="l00247"></a>00247   SCF_INTERFACE (<a class="code" href="structiDebugPrintSeqOpFactory.html" title="This interface is implemented by the seqop that prints debug messages on standard output...">iDebugPrintSeqOpFactory</a>, 0, 0, 1);
<a name="l00248"></a>00248 
<a name="l00253"></a>00253   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiDebugPrintSeqOpFactory.html#adf39da09ae179a6e38a47510bd972860" title="Set the message parameter to print (either a message string or a parameter if it starts with &#39;$&#39;)...">SetMessageParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* msg) = 0;
<a name="l00254"></a>00254 };
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00277"></a><a class="code" href="structiLightSeqOpFactory.html">00277</a> <span class="keyword">struct </span><a class="code" href="structiLightSeqOpFactory.html" title="This interface is implemented by the seqop that animates light colors.">iLightSeqOpFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00278"></a>00278 {
<a name="l00279"></a>00279   SCF_INTERFACE (<a class="code" href="structiLightSeqOpFactory.html" title="This interface is implemented by the seqop that animates light colors.">iLightSeqOpFactory</a>, 0, 0, 1);
<a name="l00280"></a>00280 
<a name="l00287"></a>00287   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiLightSeqOpFactory.html#a0ac06ac9987c5140671997d211ddbeca" title="Set the entity containing the pclight (either entity name or a parameter if it starts with &#39;$&#39;)...">SetEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entity, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag = 0) = 0;
<a name="l00288"></a>00288 
<a name="l00292"></a>00292   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiLightSeqOpFactory.html#a796ad7aa9d62e1074e7ff9e7fe272249" title="Set the relative color animation vector.">SetRelColorParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* red, <span class="keyword">const</span> <span class="keywordtype">char</span>* green,
<a name="l00293"></a>00293         <span class="keyword">const</span> <span class="keywordtype">char</span>* blue) = 0;
<a name="l00294"></a>00294 
<a name="l00298"></a>00298   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiLightSeqOpFactory.html#a3db4d24dfbbc739483ba806351e5f66f" title="Set the absolute color.">SetAbsColorParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* red, <span class="keyword">const</span> <span class="keywordtype">char</span>* green,
<a name="l00299"></a>00299         <span class="keyword">const</span> <span class="keywordtype">char</span>* blue) = 0;
<a name="l00300"></a>00300 };
<a name="l00301"></a>00301 
<a name="l00321"></a><a class="code" href="structiMovePathSeqOpFactory.html">00321</a> <span class="keyword">struct </span><a class="code" href="structiMovePathSeqOpFactory.html" title="This interface is implemented by the seqop that moves meshes along a path.">iMovePathSeqOpFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00322"></a>00322 {
<a name="l00323"></a>00323   SCF_INTERFACE (<a class="code" href="structiMovePathSeqOpFactory.html" title="This interface is implemented by the seqop that moves meshes along a path.">iMovePathSeqOpFactory</a>, 0, 0, 1);
<a name="l00324"></a>00324 
<a name="l00331"></a>00331   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiMovePathSeqOpFactory.html#a57a8bc46c39abecf2bf5ed035968f2a8" title="Set the entity containing the pcmesh (either entity name or a parameter if it starts with &#39;$&#39;)...">SetEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entity, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag = 0) = 0;
<a name="l00332"></a>00332 
<a name="l00342"></a>00342   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiMovePathSeqOpFactory.html#a3eca9c2b5b1e53ec4bf5d23c1d9a287c" title="Add a node.">AddPathNode</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* sectorname, <span class="keyword">const</span> <span class="keywordtype">char</span>* node,
<a name="l00343"></a>00343         <span class="keyword">const</span> <span class="keywordtype">char</span>* time) = 0;
<a name="l00344"></a>00344 };
<a name="l00345"></a>00345 
<a name="l00374"></a><a class="code" href="structiPropertySeqOpFactory.html">00374</a> <span class="keyword">struct </span><a class="code" href="structiPropertySeqOpFactory.html" title="This interface is implemented by the seqop that transforms property class properties.">iPropertySeqOpFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00375"></a>00375 {
<a name="l00376"></a>00376   SCF_INTERFACE (<a class="code" href="structiPropertySeqOpFactory.html" title="This interface is implemented by the seqop that transforms property class properties.">iPropertySeqOpFactory</a>, 0, 0, 1);
<a name="l00377"></a>00377 
<a name="l00382"></a>00382   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPropertySeqOpFactory.html#ab233470dfe479162c7b220da81725dd1" title="Set the entity containing the property (either entity name or a parameter if it starts with &#39;$&#39;)...">SetEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entity) = 0;
<a name="l00383"></a>00383 
<a name="l00390"></a>00390   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPropertySeqOpFactory.html#a2191e0aabbaa1605b84c75e664757e18" title="Set the property class and tag to search for.">SetPCParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* pc, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag = 0) = 0;
<a name="l00391"></a>00391 
<a name="l00397"></a>00397   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPropertySeqOpFactory.html#adc97130a002e3505e29046d8afe90003" title="Set the property name for this sequence.">SetPropertyParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* property_name) = 0;
<a name="l00398"></a>00398 
<a name="l00404"></a>00404   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPropertySeqOpFactory.html#a1dfb2fde25194b4f70f1a61264d60197" title="Set the end value for the property as a float.">SetFloatParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* pfloat) = 0;
<a name="l00405"></a>00405 
<a name="l00411"></a>00411   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPropertySeqOpFactory.html#ae17c50494a243cc9594c223c6206d0d2" title="Set the end value for the property as a long.">SetLongParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* plong) = 0;
<a name="l00412"></a>00412 
<a name="l00419"></a>00419   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPropertySeqOpFactory.html#a89aed2b392f2ddea578c8496b22f7f23" title="Set the end value for the property as a vector2.">SetVector2Parameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* vectorx, 
<a name="l00420"></a>00420         <span class="keyword">const</span> <span class="keywordtype">char</span>* vectory) = 0;
<a name="l00421"></a>00421 
<a name="l00430"></a>00430   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPropertySeqOpFactory.html#ac1f29029cc994e5a398f399cd6e54f74" title="Set the end value for the property as a vector3.">SetVector3Parameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* vectorx, <span class="keyword">const</span> <span class="keywordtype">char</span>* vectory,
<a name="l00431"></a>00431         <span class="keyword">const</span> <span class="keywordtype">char</span>* vectorz) = 0;
<a name="l00432"></a>00432 
<a name="l00440"></a>00440   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPropertySeqOpFactory.html#a405e300a1defd7d06c062c5263252ecc" title="Set whether the sequence will be relative: (end value = specified value + starting value) or absolute...">SetRelative</a> (<span class="keywordtype">bool</span> is_relative) = 0;
<a name="l00441"></a>00441 };
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00467"></a><a class="code" href="structiTransformSeqOpFactory.html">00467</a> <span class="keyword">struct </span><a class="code" href="structiTransformSeqOpFactory.html" title="This interface is implemented by the seqop that transforms meshes.">iTransformSeqOpFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00468"></a>00468 {
<a name="l00469"></a>00469   SCF_INTERFACE (<a class="code" href="structiTransformSeqOpFactory.html" title="This interface is implemented by the seqop that transforms meshes.">iTransformSeqOpFactory</a>, 0, 0, 1);
<a name="l00470"></a>00470 
<a name="l00477"></a>00477   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTransformSeqOpFactory.html#a7ba609309bff0e1ef34cb20ac729caab" title="Set the entity containing the pcmesh (either entity name or a parameter if it starts with &#39;$&#39;)...">SetEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entity, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag = 0) = 0;
<a name="l00478"></a>00478 
<a name="l00482"></a>00482   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTransformSeqOpFactory.html#aefc53204c5377ca70cca14ea3a622547" title="Set the relative movement vector parameter.">SetVectorParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* vectorx, <span class="keyword">const</span> <span class="keywordtype">char</span>* vectory,
<a name="l00483"></a>00483         <span class="keyword">const</span> <span class="keywordtype">char</span>* vectorz) = 0;
<a name="l00484"></a>00484 
<a name="l00490"></a>00490   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTransformSeqOpFactory.html#abe0f926257b63cfd2dc54a8b119ae260" title="Set the relative rotation parameter.">SetRotationParameter</a> (<span class="keywordtype">int</span> rot_axis, <span class="keyword">const</span> <span class="keywordtype">char</span>* rot_angle) = 0;
<a name="l00491"></a>00491 };
<a name="l00492"></a>00492 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00493"></a>00493 
<a name="l00497"></a>00497 <span class="preprocessor">#define CEL_DECLARE_SEQOPTYPE(name,id)                                  \</span>
<a name="l00498"></a>00498 <span class="preprocessor">class cel##name##SeqOpType : public scfImplementation2&lt;                 \</span>
<a name="l00499"></a>00499 <span class="preprocessor">        cel##name##SeqOpType,iSeqOpType,iComponent&gt;                             \</span>
<a name="l00500"></a>00500 <span class="preprocessor">{                                                                       \</span>
<a name="l00501"></a>00501 <span class="preprocessor">public:                                                                 \</span>
<a name="l00502"></a>00502 <span class="preprocessor">  iObjectRegistry* object_reg;                                          \</span>
<a name="l00503"></a>00503 <span class="preprocessor">  csWeakRef&lt;iCelPlLayer&gt; pl;                                            \</span>
<a name="l00504"></a>00504 <span class="preprocessor">  cel##name##SeqOpType (iBase* parent);                 \</span>
<a name="l00505"></a>00505 <span class="preprocessor">  virtual ~cel##name##SeqOpType () { }                                  \</span>
<a name="l00506"></a>00506 <span class="preprocessor">  virtual bool Initialize (iObjectRegistry*)    ;               \</span>
<a name="l00507"></a>00507 <span class="preprocessor">  virtual const char* GetName () const { return id; }                   \</span>
<a name="l00508"></a>00508 <span class="preprocessor">  virtual csPtr&lt;iSeqOpFactory&gt; CreateSeqOpFactory ();           \</span>
<a name="l00509"></a>00509 <span class="preprocessor">};</span>
<a name="l00510"></a>00510 <span class="preprocessor"></span>
<a name="l00514"></a>00514 <span class="preprocessor">#define CEL_IMPLEMENT_SEQOPTYPE(name)                                   \</span>
<a name="l00515"></a>00515 <span class="preprocessor">cel##name##SeqOpType::cel##name##SeqOpType (                            \</span>
<a name="l00516"></a>00516 <span class="preprocessor">        iBase* parent) : scfImplementationType (this, parent),  \</span>
<a name="l00517"></a>00517 <span class="preprocessor">        object_reg(0)                                                                                   \</span>
<a name="l00518"></a>00518 <span class="preprocessor">{                                                                                                                       \</span>
<a name="l00519"></a>00519 <span class="preprocessor">}                                                                                                                       \</span>
<a name="l00520"></a>00520 <span class="preprocessor">bool cel##name##SeqOpType::Initialize (                                 \</span>
<a name="l00521"></a>00521 <span class="preprocessor">        iObjectRegistry* object_reg)                                                    \</span>
<a name="l00522"></a>00522 <span class="preprocessor">{                                                                                                                       \</span>
<a name="l00523"></a>00523 <span class="preprocessor">  cel##name##SeqOpType::object_reg = object_reg;                        \</span>
<a name="l00524"></a>00524 <span class="preprocessor">  pl = csQueryRegistry&lt;iCelPlLayer&gt; (object_reg);                       \</span>
<a name="l00525"></a>00525 <span class="preprocessor">  return true;                                                                                          \</span>
<a name="l00526"></a>00526 <span class="preprocessor">}                                                                       \</span>
<a name="l00527"></a>00527 <span class="preprocessor">csPtr&lt;iSeqOpFactory&gt; cel##name##SeqOpType::CreateSeqOpFactory ()        \</span>
<a name="l00528"></a>00528 <span class="preprocessor">{                                                                       \</span>
<a name="l00529"></a>00529 <span class="preprocessor">  cel##name##SeqOpFactory* fact = new cel##name##SeqOpFactory (this);   \</span>
<a name="l00530"></a>00530 <span class="preprocessor">  return fact;                                                          \</span>
<a name="l00531"></a>00531 <span class="preprocessor">}</span>
<a name="l00532"></a>00532 <span class="preprocessor"></span>
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 <span class="preprocessor">#endif // __CEL_SEQUENCES__</span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
